namedRegExp = require('named-regexp').named

class RegExpResolver extends Object
  constructor:()->
    @patternCache = {}

  isMatch:(pattern,value)->
    return @regExpForPattern(pattern).test(value)

  matchesForPattern:(pattern,value)->
    match = @regExpForPattern(pattern).exec(value)
    captures = {}
    for key,_ of match.captures
      captures[key] = match.capture(key)
    return captures

  regExpForPattern:(pattern)->
    re = @patternCache[pattern]
    if not re
      re = namedRegExp(new RegExp(pattern.replace(/\*/,'.*').replace(/(:([a-zA-Z]+))/g,'(:<$2>[^/]+)')))
      @patternCache[pattern] = re
    return re

module.exports = RegExpResolver